/*** cgf_win.c --- Windows95Ɉˑ镔Ɋ܂ --- ***/
#include <Windows.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>

#include "cgf.h"
#include "cgf_rc.h"
#include "gnugo.h"

extern unsigned char p[19][19];   /* go board */
extern int mymove, umove;         /* computer color, opponent color */
extern int lib;                   /* current stone liberty */
extern int pass;                  /* pass indicator */
extern int mk, uk;    /* no. of stones captured by computer and oppoent */
extern int mik, mjk;             /* location of computer stone captured */
extern int uik, ujk;             /* location of opponent stone captured */


/* vg^Cv錾 ---------------------- ȉWindowsŗL̐錾܂ */
LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM );
LRESULT CALLBACK DrawWndProc( HWND, UINT, WPARAM, LPARAM );
LRESULT CALLBACK PrintProc( HWND, UINT, WPARAM, LPARAM );
LRESULT CALLBACK AboutDlgProc( HWND, UINT, WPARAM, LPARAM );

BOOL CALLBACK StartProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
void PaintScreen( HWND hWnd );
void GetScreenParam( HWND hWnd,int *dx, int *sx,int *sy, int *db );
int ChangeXY(LONG lParam);
void SetIshi( int z, int flag );
void OpenPrintWindow(HWND);
void KifuSave(void);
void KifuOpen(void);
void PaintLittle(void);		// 

//////////////// from aya_term.c
BOOL NEAR OpenConnection( void );
BOOL NEAR CloseConnection( void );
int WhiteStart(void);		// ԂŊJnB
int BlackStart(void);		// ԂŊJnB
BOOL SendMove(int z);		// w  𑗂
int WaitMove(void);			// ҂
///////////////////////////////


void PRT(char *fmt, ...);	// ς̃Xgprintfp֐
void PRT_Scroll(void);
void BreakPoint(void);
void move_tesuu(int n);		// Cӂ̎萔̋ǖʂɔՖʂړ


HWND ghWindow;					/* WINDOWS̃nh  */
HANDLE ghInstance;				/* CX^X       */
HWND hPrint = NULL;				/* o͗p̃[hX_CAO */
HWND hWndDraw;
HWND hWndMain;

#define PMaxY 400				// ʂ̏cTCYiSj
#define PHeight 25				// ʂ̕W 
#define IsKanji(c) (( 0x80<(c) && (c)<0xa0 ) || ( 0xdf<(c) && (c)<0xfd ))	// ̐擪oCgH

char cPrintBuff[PMaxY][256];	// obt@			
static int nHeight;
static int nWidth;
static int PRT_y;
static int PRT_x = 0;


int fFileWrite = 0;				// t@CɏރtO
int fSoundDrop = 1;				// 艹Ȃ
int fSelfPlay = 0;				// SelfPlay
int ban_size = 19;

int gnugo_color;				// gnugo's color (WHITE = 1 BLACK = 2)
int user_color;					// user's  color

int RetZ;		// ʐMŎ󂯎w
int ban_size;

int tesuu = 0;		// 萔

int ban[BANMAX];		// ban[5376];	// = 21*256

//int all_tesuu = 0;	// Ō܂ł̎萔
int kifu[1024][4];	// 	[0] ʒu, [1] F, [2] 

char sPlayerName[2][256];	// F̑΋ǎ҂̖O

int nCommNumber = 1;	// COM|[g̔ԍB


int PASCAL WinMain( HANDLE hInstance, 
					HANDLE hPrevInstance,
					LPSTR  lpszCmdLine,
					int    cmdShow )
{
	MSG      msg;
	WNDCLASS wc;
	static char szAppName[] = "cgf";
	static HBRUSH hBrush = NULL;

	ghInstance = hInstance;

	if ( !hPrevInstance ) {
		wc.lpszClassName = szAppName;
		wc.hInstance     = hInstance;
		wc.lpfnWndProc   = WndProc;
		wc.hCursor       = LoadCursor( NULL, IDC_ARROW);
//		wc.hCursor       = LoadCursor( hInstance, "BLACK_CURSOR");
		wc.hIcon         = LoadIcon( hInstance, "cgf" );
		wc.lpszMenuName  = szAppName;
//		hBrush = CreateSolidBrush( RGB( 0,128,0 ) );	// wi΂(wc.̃IuWFNg͏IɎIɍ폜j
//		wc.hbrBackground = hBrush;//	GetStockObject(WHITE_BRUSH);
	    wc.hbrBackground = GetStockObject(LTGRAY_BRUSH); 
		wc.style         = CS_HREDRAW | CS_VREDRAW;
		wc.cbClsExtra    = 0;
		wc.cbWndExtra    = 0;
		if (!RegisterClass( &wc )) return FALSE;		/* NX̓o^ */


	    wc.style         = CS_HREDRAW | CS_VREDRAW;
	    wc.lpfnWndProc   = DrawWndProc;
	    wc.cbClsExtra    = 0;
	    wc.cbWndExtra    = 4;
	    wc.hInstance     = hInstance;
	    wc.hIcon         = NULL;
	    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
//		hBrush = CreateSolidBrush( RGB( 0,128,0 ) );	// wi΂(wc.̃IuWFNg͏IɎIɍ폜j
//		wc.hbrBackground = hBrush;//	GetStockObject(WHITE_BRUSH);
		wc.hbrBackground = GetStockObject(BLACK_BRUSH);
	    wc.lpszMenuName  = NULL;
	    wc.lpszClassName = "DrawWndClass";
	    if (! RegisterClass (&wc)) return FALSE;
	}
	else {
//		MessageBox(NULL,"ʂQN悤ƂĂ܂\nIĂ","Ƃ܂I",MB_OK);
//		return FALSE;
	}

	/********** EChE̍쐬 ********/
	hWndMain = CreateWindow(
						szAppName,						/* Class name.   */                                  
						"CGF GnuGo",      				/* Title.        */
						WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,			/* Style bits.   */
						CW_USEDEFAULT, 0,				/* X,Y - default.*/
						600,480,						/* CX, CY        */
						NULL,							/* e͂Ȃ      */
						NULL,							/* Class Menu.   */
						hInstance,						/* Creator       */
						NULL							/* Params.       */
					   );
	
	ghWindow = hWndMain;

//	if ( *lpszCmdLine ) strcpy(cDragFile,lpszCmdLine);		// hbOꂽJׂt@C
	ShowWindow( hWndMain, cmdShow );
	UpdateWindow(hWndMain);

	while( GetMessage( &msg, 0, 0, 0) ) {
		TranslateMessage( &msg );						/* keyboard input. */
		DispatchMessage( &msg );
	}
	return msg.wParam;
}

/************** EBhE葱 ****************/						
LRESULT CALLBACK WndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	HMENU hMenu;
	static HDC hDC;
	int k,z;

	switch( msg ) {
		case WM_CREATE:											// ݒ
            // `pWindow̐
			if (!(hWndDraw = CreateWindowEx(WS_EX_CLIENTEDGE,
	            "DrawWndClass", NULL,
	            WS_CHILD | WS_VISIBLE, 
	            // 0, 0, rect.right, rect.bottom - nStatusHeight,
	            0, 0, 100, 100,
	            hWnd, NULL, ghInstance, NULL))) return FALSE;

			SendMessage(hWnd,WM_COMMAND,IDM_PRINT,0L);		// \Window̕\
			SendMessage(hWnd,WM_COMMAND,IDM_BAN_CLEAR,0L);	// ʏ gnugo Engine ̏

			return 0;
			
		case WM_COMMAND:
			switch (wParam) {
				case IDM_EXIT:
					DestroyWindow(hWnd);
					break;
			
				case IDM_TEST:
//					PRT("ret=%d\n",initcom(2) );
					
//					test_cgfcom();

//					p[3][5] = 2;
//					p[8][5] = 1;
//					p[9][5] = 1;


					InvalidateRect(hWndDraw, NULL, TRUE);
					break;


				case IDM_THINKING:
					z = thinking();

//					PRT("= %d b,ꏊ= %04x,萔=%d\n",t2-t1,z,tesuu+1);
//					PRT("----------------------------------------------\n");
					tesuu++;
					kifu[tesuu][0] = z;
//					ban[z] = 0;

					PaintLittle();

//					fCommLate = 1;
//					Delay(500);

//					if ( fSoundDrop ) MessageBeep(MB_OK);	// 炵Ă݂܂

//					InvalidateRect(hWndDraw, NULL, TRUE);
					break;
				
				case IDM_START_COMM:
					// ʐM֐̐䕔B{Iɖ[v
					if ( OpenConnection() == FALSE ) {
						PRT("Comm port Open Error!\n");
						break;
					}
//					PRT("ΐ퐔=%d, Z[u=%d\n",ContinuousNum,fAutoSave);
					if ( gnugo_color == BLACK ) {	// ʂij̎ NEWGAME 𑗂
						if ( BlackStart() == FALSE ) {	// Jn
							PRT("NewGame Error! Stop Communucation.\n");
							CloseConnection();
							break;
						}
						goto Sente;	// őł
					} else {		// ʂԂ̎
						if ( WhiteStart() == FALSE ) {	// Jn
							PRT("Stop Communucation.\n");
							CloseConnection();
							break;
						}
					}
					// ΋Ǘp̃C[v							
					for ( ;; ) {
						RetZ = WaitMove();
						if ( RetZ < 0 ) {
							PRT("Stop Communication.\n");
							break;
						}
//						PRT("RetZ = %x\n",RetZ);
						if ( RetZ != 0 ) {	// 肪pX
//							te[fukasa][0].iti = RetZ;
//							te[fukasa][0].color = user;
//							k = add_stone( &te[fukasa][0] );
//							if ( k != 0 ) {
//								MessageBox(hWnd,"肪[ᔽȁAƎv","ł̃G[",MB_OK);
//								break;
//							}
//							kari_ren_erase();

							/////////
							{
								int x,y;

								y = RetZ / 256;
								x = RetZ & 0x00ff;
								p[y-1][x-1] = user_color;
								examboard(gnugo_color);   // remove your dead pieces 
							}
					
							ban[RetZ] = 0;
							SetIshi( RetZ, user_color );	// ban[z] user ̐΂u

						}
//						else kou_iti = 0;	// PASS̎̓RE𖳂̂Yꂸ

						tesuu++;	// all_tesuu = tesuu;
						kifu[tesuu][0] = RetZ;	// L
//						kifu[tesuu][1] = user_color;	// ΂̐F

						if ( RetZ==0 ) {
							if ( kifu[tesuu-1][0] == 0 && tesuu > 1 ) {
								MessageBox(hWnd,"Two Pass","Game end",MB_OK);
//								ContinuousPlay();	// AʐMΐ̏IǏ
								break;
							}
						}

						if ( tesuu > 500 ) {
							MessageBox(hWnd,"Moves over 500! Maybe Three KO.","Play Stop",MB_OK);
							break;
						}

						///
						PaintLittle();
//						UpdateWindow(hWndDraw);
						///

Sente:
						z = thinking();
//						PRT("time= %d (s), Node=%d\n",t2-t1,tesuu+1);
//						PRT("------------------------------------ Communication now.\n");

						if ( z != 0 ) {		// pX
//							te[fukasa][0].iti = z;
//							te[fukasa][0].color = aya;
//							k = add_stone( &te[fukasa][0] );
//							kari_ren_erase();
//							pass_flag = 0;
						}
//						else kou_iti = 0;	// PASS̎̓RE𖳂̂Yꂸ

						tesuu++;
//						all_tesuu = tesuu;
						kifu[tesuu][0] = z;	// L
//						kifu[tesuu][1] = gnugo_color;	// ΂̐F

						SendMove(z);

						PaintLittle();

						if ( z==0 ) {
							if ( kifu[tesuu-1][0] == 0 && tesuu > 1 ) {
								MessageBox(hWnd,"Two Pass.","End game",MB_OK);
//								ContinuousPlay();	// AʐMΐ̏IǏ
								break;
							}
						}
					}
					CloseConnection();	// breakŔɒʐMN[Y
					break;


				case IDM_PASS:
					tesuu++;	//	all_tesuu = tesuu;
					kifu[tesuu][0] = 0;	// L
					kifu[tesuu][1] = 0;	// ΂̐F
					PRT("Pass... Moves = %d\n",tesuu);
//					kou_iti = 0;			// PASS̎̓RE𖳂̂Yꂸ
//					PostMessage(hWnd,WM_COMMAND,IDM_THINKING,0L);	// vl[`ɓ
					return 0;

				case IDM_PLAY_START:
					DialogBox(ghInstance, "START_DIALOG", hWnd, StartProc);
					InvalidateRect(hWndDraw, NULL, TRUE);		// ̖OXV邽ߑSʏB
					break;

				case IDM_SELF_PLAY:
					PRT("Now Starting Self Play...\n");
					fSelfPlay = 1;
//					sprintf( sPlayerName[0],"Aya");
//					sprintf( sPlayerName[1],"Aya");
					InvalidateRect(hWndDraw, NULL, TRUE);		// ̖OXV邽ߑSʏB
					for ( ;; ) {
						// gľ
						k  = uk; uk = mk; mk = k;
						// Rs[^OɎ΂̌iREĂj
						{
							int ki,kj;

							ki  = mik; kj  = mjk;
							mik = uik; mjk = ujk;
							uik = ki;  ujk = kj;
						}

						SendMessage(hWnd,WM_COMMAND,IDM_THINKING,0L);	// vl[`ɓ

						if ( kifu[tesuu][0] == 0 && kifu[tesuu-1][0] == 0 ) {
							PRT("Two pass. Game end.\n");
							break;
						}
						if ( tesuu >= 500 ) {
							PRT("Too moves! Maybe three Ko... Stop self play.\n");
							break;
						}
					}
					PRT("End Self Play... tesuu=%d \n",tesuu);
					fSelfPlay = 0;
					break;

				case IDM_HYOUKATI:
					PRT("This is test.\n");
//					print_hyoukati();
//					hyouji_text();
					break;


				case IDM_TEXT_HYOUJI:
					PRT("Print out board.\n");
					showboard();
//					hyouji_text();
					break;

				case IDM_PRINT:
					hMenu = GetMenu(hWnd);
					if ( hPrint==NULL || IsWindow(hPrint)==FALSE ) {
						CheckMenuItem(hMenu, IDM_PRINT, MF_CHECKED);
						OpenPrintWindow(hWnd);
					}
					else {
						DestroyWindow(hPrint);
						hPrint = NULL;
						CheckMenuItem(hMenu, IDM_PRINT, MF_UNCHECKED);
					}
					break;

				case IDM_SOUND:
					hMenu = GetMenu(hWnd);
					fSoundDrop = (fSoundDrop == 0);	// 艹tO
					if ( fSoundDrop ) CheckMenuItem(hMenu, IDM_SOUND, MF_CHECKED);
					else              CheckMenuItem(hMenu, IDM_SOUND, MF_UNCHECKED);
					break;

				case IDM_BAN_CLEAR:
					initialize_gnugo();
					sprintf( sPlayerName[0],"GnuGo 1.2");		// set player name
					sprintf( sPlayerName[1],sPlayerName[0]);
					tesuu = 0;								// node
					InvalidateRect(hWndDraw, NULL, TRUE);	// Screen celar
					break;

				case IDM_KIFU_SAVE:
					KifuSave();
					break;

				case IDM_FILE_WRITE:
					fFileWrite = (fFileWrite == 0);
					hMenu = GetMenu(hWnd);
					CheckMenuItem(hMenu, IDM_FILE_WRITE, (fFileWrite ? MF_CHECKED : MF_UNCHECKED) );
					break;

				case IDM_HELP:
					WinHelp( hWnd, "cgfgnugo.hlp", HELP_INDEX, 0);
					break;

				case IDM_ABOUT:
					DialogBox( ghInstance, "ABOUT_DIALOG", hWnd, AboutDlgProc);
					break;
			}
			return 0;


		case WM_SIZE:
			// Make the draw window the size of the window's client area. 
			MoveWindow(hWndDraw, 0, 0, LOWORD(lParam), HIWORD(lParam), TRUE);          
			break;

		case WM_DESTROY:
			WinHelp( hWnd, "cgfgnugo.hlp", HELP_QUIT, 0);
			PostQuitMessage(0);
			break;
		
		default:
			return( DefWindowProc( hWnd, msg, wParam, lParam) );
			break;
	}
	return 0L;
}

/* \_CAO */
void OpenPrintWindow(HWND hWnd)
{
	WNDCLASS wc;
	HBRUSH hBrush;
	RECT rc;
	static bFirstTime = TRUE;

	if ( bFirstTime ) {
		bFirstTime = FALSE;
		wc.style         = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;//PARENTDC;
		wc.lpszClassName = "PrintClass";
		wc.hInstance     = ghInstance;
		wc.lpfnWndProc   = PrintProc;
		wc.hCursor       = LoadCursor( NULL, IDC_CROSS);
		wc.hIcon         = LoadIcon( ghInstance, "cgf" );
		wc.lpszMenuName  = NULL;
		hBrush = CreateSolidBrush( RGB( 0,0,128 ) );	// wi΂(wc.̃IuWFNg͏IɎIɍ폜j
		wc.hbrBackground = hBrush;//	GetStockObject(WHITE_BRUSH);
//		wc.hbrBackground = GetStockObject(BLACK_BRUSH);
		wc.cbClsExtra    = 0;
		wc.cbWndExtra    = 0;
		if ( !RegisterClass(&wc) ) MessageBox(ghWindow,"Failed to regist Information Window","Error",MB_OK);
	}
	
	// Get Parent Window Position
	if ( GetWindowRect(hWnd, &rc) == FALSE ) rc.right = rc.top = CW_USEDEFAULT;	// size unknown

	/********** EChE̍쐬 ********/
	hPrint = CreateWindow(
				"PrintClass",						/* Class name.   */                                  
				"Information Window",				/* Title.        */
				WS_VSCROLL | WS_OVERLAPPEDWINDOW,	/* Style bits.   */
				rc.right, rc.top,					/* X,Y  \W */
//				600, 50,							/* X,Y  \W */
				700,480,							/* CX, CY 傫 */
//				600,560,							/* CX, CY 傫 */
				hWnd,								/* e͂Ȃ      */
				NULL,								/* Class Menu.   */
				ghInstance,							/* Creator       */
				NULL								/* Params.       */
			   );

	ShowWindow( hPrint, SW_SHOW);
}

LRESULT CALLBACK PrintProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	int i,y;
	PAINTSTRUCT ps;
	HMENU hMenu;
	TEXTMETRIC tm;
	static HDC hDC;
	static HFONT hOldFont;

	switch( msg ) {
		case WM_CREATE:
			PRT_y = PMaxY - PHeight;		// {25s\
			SetScrollRange( hWnd, SB_VERT, 0, PRT_y, FALSE);	
			SetScrollPos( hWnd, SB_VERT, PRT_y, FALSE );
			hDC = GetDC(hWnd);

			hOldFont = SelectObject(hDC,GetStockObject(SYSTEM_FIXED_FONT));

			GetTextMetrics(hDC, &tm);
			nHeight = tm.tmHeight;
			nWidth  = tm.tmAveCharWidth;
			SetTextColor( hDC, RGB(255,255,255) );	//@𔒂
			SetBkColor( hDC, RGB(0,0,128) );		//@wiZ΂
			ReleaseDC( hWnd, hDC );
			break;

		case WM_PAINT:
			hDC = BeginPaint(hWnd, &ps);
			for (i=PRT_y; i<PMaxY; i++) {
				TextOut(hDC,0,(i-PRT_y)*(nHeight),cPrintBuff[i],strlen(cPrintBuff[i]));
			}
			EndPaint(hWnd, &ps);
			break;
		
		case WM_KEYDOWN:
		case WM_VSCROLL:
			y = PRT_y;
			switch ( (int)LOWORD(wParam) ) {
				case SB_THUMBPOSITION:	// Tړ
					PRT_y = (short int) HIWORD( wParam );
//					PRT("wParam=%x ,(short int)HIWORD()=%d, lParam=%x\n",wParam,(short int )HIWORD(wParam ),lParam );
					break;
				case SB_LINEDOWN:
				case VK_DOWN:
					PRT_y++;
					break;
				case SB_PAGEDOWN:
				case VK_NEXT:
					PRT_y += PHeight - 1;
					break;
				case SB_LINEUP:
				case VK_UP:
					PRT_y--;
					break;
				case SB_PAGEUP:
				case VK_PRIOR:
					PRT_y -= PHeight - 1;
					break;
			}
			if ( PRT_y <= 0 ) PRT_y = 0;
			if ( PRT_y >= PMaxY - PHeight ) PRT_y = PMaxY - PHeight;
			
			SetScrollPos( hWnd, SB_VERT, PRT_y, TRUE);
			if ( y != PRT_y ) {
//				hDC = GetDC( hWnd );
//				GetTextMetrics(hDC, &tm);
//				GetClientRect( hWnd, &rc );
				ScrollWindow( hWnd, 0, (nHeight) * (y-PRT_y), NULL, NULL );
//				ReleaseDC( hWnd, hDC );
			}
			break;

		case WM_DESTROY:
			hMenu = GetMenu(ghWindow);
			CheckMenuItem(hMenu, IDM_PRINT, MF_UNCHECKED);
			SelectObject(hDC, hOldFont);	// tHgɒuB
			break;

		default:
			return( DefWindowProc( hWnd, msg, wParam, lParam) );
			break;
	}
	return 0L;
}


/* AoEg̕\ */
LRESULT CALLBACK AboutDlgProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch( msg ) {
		case WM_INITDIALOG:
			SetFocus(hDlg);
			break;

		case WM_COMMAND:
			switch (wParam) {
				case IDOK:
					EndDialog( hDlg, 0);
					return TRUE;
			}
			return TRUE;

		case WM_CLOSE:
		case WM_DESTROY:
			EndDialog( hDlg, 0);
			return TRUE;
	}
	return FALSE;
}

// ΋Ǐݒ肷_CAO{bNX֐
BOOL CALLBACK StartProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg) {
		case WM_INITDIALOG:
			SetFocus(hDlg);
			if ( nCommNumber == 1 ) CheckDlgButton(hDlg, IDM_COM1, 1);
			else                    CheckDlgButton(hDlg, IDM_COM2, 1);
			sprintf( sPlayerName[0],"you");
			sprintf( sPlayerName[1],sPlayerName[0]);
			SetDlgItemText(hDlg, IDM_MAN_NAME, sPlayerName[0]);
			break;

			break;

		case WM_COMMAND:
			if ( wParam == IDCANCEL ) EndDialog(hDlg,FALSE);		// LZ
			if ( wParam == IDOK ) {
				if ( IsDlgButtonChecked( hDlg, IDM_AYA_SENTE ) ) {	// gnugoijH
					gnugo_color = BLACK;	// black = 2
					user_color	= WHITE;	// white = 1
				} else {
					gnugo_color = WHITE;
					user_color	= BLACK;
				}

				if ( IsDlgButtonChecked( hDlg, IDM_COM1) ) nCommNumber = 1;		// COM1gB
				else nCommNumber = 2;	

				PostMessage(ghWindow,WM_COMMAND,IDM_START_COMM,0L);		// ʐM΋ǂ̊Jn

				GetDlgItemText(hDlg, IDM_MAN_NAME, sPlayerName[gnugo_color-1], 32);	// O擾
				sprintf( sPlayerName[user_color-1],"gnugo 1.2");

				EndDialog(hDlg,FALSE);			
			}
			return TRUE;
	}
	return FALSE;
}

/*** `pqWINDOW̏BWindowɕ`sB ***/
LRESULT CALLBACK DrawWndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch( msg ) {
		case WM_PAINT:
			PaintScreen(hWnd);
			return 0;

		default:
			return( DefWindowProc( hWnd, msg, wParam, lParam) );
			break;
	}
	return 0L;
}



/*** Z[u ***/
void KifuSave(void)
{
	OPENFILENAME ofn;
	char szDirName[256];
	char szFile[256], szFileTitle[256];
	UINT  cbString;
	char  chReplace;    /* szFilter̋؂蕶 */
	char  szFilter[256];
	char  lpSend[256];	// ݗp̃f[^
	char  Title[256];	// Title
	HANDLE hFile;		// t@C̃nh
	int i,j,x,y,z;
	int RetByte;		// ܂ꂽoCgi_~[j
	static int OnlyOne = 0;	// Aΐ̉񐔁iŏ1񂾂܂)B

	time_t timer;
	struct tm *tblock;
//	static char *toJPN[] = { "","","","","","","y" };
	unsigned int year,month,day,week,hour,minute,second;

	/* VXe fBNg擾szDirNameɊi[ */
	GetSystemDirectory(szDirName, sizeof(szDirName));
	szFile[0] = '\0';

	if ((cbString = LoadString(ghInstance, IDS_SAVE_FILTER,
	        szFilter, sizeof(szFilter))) == 0) {
	    return;
	}
	chReplace = szFilter[cbString - 1]; /* Ch J[h擾 */

	for (i = 0; szFilter[i] != '\0'; i++) {
	    if (szFilter[i] == chReplace)
	       szFilter[i] = '\0';
	}


	/* ̎擾 */
	timer = time(NULL);
	tblock = localtime(&timer);   /* t^\̂ɕϊ */
//	PRT("Local time is: %s", asctime(tblock));
	second = tblock->tm_sec;      /* b */
	minute = tblock->tm_min;      /*  */
	hour   = tblock->tm_hour;     /*  (0`23) */
	day    = tblock->tm_mday;     /* ̒ʂ (1`31) */
	month  = tblock->tm_mon+1;    /*  (0`11) */
	year   = tblock->tm_year;     /* N ( - 1900) */
	week   = tblock->tm_wday;     /* j (0`6; j = 0) */
//	PRT( "Date %02x-%02d-%02x / Time %02x:%02x:%02x\n", year, month, day, hour, minute, second );

//	sprintf( szFileTitle, "%02d%02d%02d%02d", month, day, hour, minute );	// t@Ct{b
	sprintf( szFile, "%x%02d-%02d%02d", month, day, hour, minute );	// t@Ct{b


	/* \ׂ̂̂Ẵo0ɐݒ */
	memset(&ofn, 0, sizeof(OPENFILENAME));

	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = ghWindow;
	ofn.lpstrFilter = szFilter;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile= szFile;
	ofn.nMaxFile = sizeof(szFile);
	ofn.lpstrFileTitle = szFileTitle;
	ofn.nMaxFileTitle = sizeof(szFileTitle);
//	ofn.lpstrInitialDir = szDirName;
	ofn.lpstrInitialDir = NULL;		// JgfBNg
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
	ofn.lpstrDefExt	= "sgf";	// ftHg̊gq ".ig1" 
	
	if ( GetSaveFileName(&ofn) ) {
		hFile = CreateFile(ofn.lpstrFile,      /* create MYFILE.TXT  */
	             GENERIC_WRITE,                /* open for writing   */
	             0,                            /* do not share       */
		         (LPSECURITY_ATTRIBUTES) NULL, /* no security        */
			     CREATE_ALWAYS,                /* overwrite existing */
				 FILE_ATTRIBUTE_NORMAL,        /* normal file        */
	             (HANDLE) NULL);               /* no attr. template  */
		if (hFile == INVALID_HANDLE_VALUE) {
			PRT("Could not open file.");       /* process error      */
			return;
		}

		// ^CgɃt@Ct
		sprintf(Title,"CGF GnuGo - %s",ofn.lpstrFile);
		SetWindowText(ghWindow, Title);

		// SGF (Standard Go Format) ŏށB
		sprintf(lpSend,"(;\r\n"); WriteFile( hFile,(void *)lpSend, strlen(lpSend), &RetByte, NULL );
		sprintf(lpSend,"GM[1]FF[1]SZ[%d]\r\n",ban_size); WriteFile( hFile,(void *)lpSend, strlen(lpSend), &RetByte, NULL );
		sprintf(lpSend,"PB[%s]\r\n",sPlayerName[0]); WriteFile( hFile,(void *)lpSend, strlen(lpSend), &RetByte, NULL );
		sprintf(lpSend,"PW[%s]\r\n",sPlayerName[1]); WriteFile( hFile,(void *)lpSend, strlen(lpSend), &RetByte, NULL );
		sprintf(lpSend,"DT[19%02d-%02d-%02d]\r\n",year,month,day); WriteFile( hFile,(void *)lpSend, strlen(lpSend), &RetByte, NULL );
		sprintf(lpSend,"KM[5.5]TM[60]"); WriteFile( hFile,(void *)lpSend, strlen(lpSend), &RetByte, NULL );
		sprintf(lpSend,"RU[Japanese]\n"); WriteFile( hFile,(void *)lpSend, strlen(lpSend), &RetByte, NULL );

		j = 0;
		for ( i=1;i<tesuu+1; i++ ) {
			z = kifu[i][0];
			if ( z != 0 ) {
				x = z & 0x00ff;
				y = (z & 0xff00) >> 8;
			} else {
				x = 20;
				y = 20;
			}
			if ( i&1 ) sprintf(lpSend,";B[%c%c]",x+'a'-1, y+'a'-1 );
			else       sprintf(lpSend,";W[%c%c]",x+'a'-1, y+'a'-1 );
			WriteFile( hFile,(void *)lpSend, strlen(lpSend), &RetByte, NULL );
			j++;
			if ( j==10 ) {
				sprintf(lpSend,"\r\n"); WriteFile( hFile,(void *)lpSend, strlen(lpSend), &RetByte, NULL );
				j = 0;
			}
		}
		sprintf(lpSend,")\r\n"); WriteFile( hFile,(void *)lpSend, strlen(lpSend), &RetByte, NULL );
		CloseHandle(hFile);		// t@CN[Y
	}
}

/*** [h ***/
void KifuOpen(void)
{
}


/*** printf ̑p ***/
void PRT(char *fmt, ...)
{
	va_list ap;
	int i,len,x,y,nRet = 1;
	char c,text[256];
	static FILE *fp;
	RECT rc;
	HDC hDC;

	va_start(ap, fmt);
	vsprintf( text , fmt, ap );

	//// FILEop ////
	if ( fFileWrite == 1 ) {
		fp = fopen("output","a");
		fprintf(fp,text);
		fclose(fp);
	}
	////////////////////


//	SendMessage(hWndEdit, WM_PASTE, 0, 0);

//	y = SendMessage(hWndEdit, EM_GETLINECOUNT, 0, 0L);	// ݂̍s擾

//	SendMessage(hWndEdit, WM_SETTEXT, 0, (LPARAM) text);
//DIT

//	PRT_Scroll();

	len = (int)strlen(text);
	for (i=0;   i<len; i++) {
		c = text[i];
		if ( c == '\n' ) {nRet++;PRT_Scroll();}
		else {
			cPrintBuff[PMaxY-1][PRT_x] = c;
			if ( PRT_x == 99 ) {nRet++;PRT_Scroll();}	// 100s
			else PRT_x++;
		}
	}
	if ( hPrint != NULL && IsWindow(hPrint) ) {
		if ( nRet == 1 ) {	// XN[Ȃꍇ`
//			rc.left  = (PRT_x-len)*nWidth;
//			rc.right =  PRT_x     *nWidth;
			hDC = GetDC(hPrint);
			x = PRT_x - len;
			y = PMaxY -1;
			TextOut(hDC,x*nWidth,(y-PRT_y)*(nHeight),&cPrintBuff[y][x],strlen(&cPrintBuff[y][x]));
			ReleaseDC(hPrint,hDC);
		} else {
			ScrollWindow( hPrint, 0, -nHeight*(nRet-1), NULL, NULL );
			GetClientRect( hPrint, &rc);
			rc.top    = (PMaxY-PRT_y - nRet)*nHeight;
			rc.bottom = (PMaxY-PRT_y       )*nHeight;
			InvalidateRect(hPrint, &rc, TRUE);
			UpdateWindow(hPrint);
		}
	}
//	MessageBox( ghWindow, text, "Printf Debug", MB_OK);

	va_end(ap);
}

void PRT_Scroll(void)
{
	int i,j;

	for (i=1;i<PMaxY;i++) {
		for (j=0;j<128;j++) cPrintBuff[i-1][j] = cPrintBuff[i][j];
	}
	for (i=0; i<128; i++) cPrintBuff[PMaxY-1][i] = 0;
	PRT_x = 0;
}

/*** G[ ***/
void BreakPoint(void)
{
	MessageBox( ghWindow, "Stop for internal error.", "Debug!", MB_OK);
}

void debug(void)
{
	PRT("debug!!!\n");
	BreakPoint();	// WindowspMessageBox\B
	exit(1);
}


/*** ͌Ղ̏Wl擾i͌Վ̂̏kɔj***/
void GetScreenParam( HWND hWnd,int *dx, int *sx,int *sy, int *db )
{
	RECT rc;
	
	GetClientRect( hWnd, &rc );

	*sx = 22;			// ͌Ղ̍[W	 
	*sy = 20;

	*dx = 2*(rc.bottom - *sy - 15) / ( 2*ban_size+1);	// -15 ͋C
		
	if ( *dx <= 18 ) *dx = 18;	// Œ18
	if ( *dx & 1 ) *dx -= 1;	// 
//	if ( !(*dx & 2) ) *dx -= 2;	// 18 + 4*x ̔{

	*db = (*dx*3) / 4;	// ͌Ղ̒[Ɛ̊Ԋu
	if ( !(*db & 1) ) *db += 1;	// 
//	if ( iBanSize==BAN_19 ) *dx = 26;
//	if ( iBanSize==BAN_13 ) *dx = 38;
//	if ( iBanSize==BAN_9  ) *dx = 50;
//	*dx = 26;		// ڂ̊Ԋu (640*480..20, 800*600..25, 1280*780..34)
					// 18 <= dx <= 36 (24 +- 4 ̔{͈ÂՂŘgɂ)
}
/*** WM_PAINT ŉʂĕ`悷֐ ***/
void PaintScreen( HWND hWnd )
{
	HDC hDC;
	PAINTSTRUCT ps;
	HBRUSH hBrush,hBrushWhite,hBrushBlack;
	HPEN hPen,hPenOld;
	HFONT hFont,hFontOld;
//	TEXTMETRIC tm;
	RECT rRect;
	
	int dx,sx,sy,db;
	int x,y,z,xx,yy,i,j,k;
	char sNum[256];

	GetScreenParam(	hWnd,&dx,&sx,&sy,&db );
//	db = 10; dx = 10; sx = 12; sy = 15;

	hDC = BeginPaint(hWnd, &ps);

	hBrushBlack = CreateSolidBrush( RGB( 0,0,0 ) );			// 
	hBrushWhite = CreateSolidBrush( RGB( 255,255,255 ) );	// 

	SetTextColor( hDC, RGB(255,255,255) );	//@𔒂
//	SetBkColor( hDC, RGB(0,128,0) );		//@wiZ΂
	SetBkColor( hDC, RGB(0,0,0) );		//@wiZ΂

	/* ՖʑŜ̕\ */
	SetRect( &rRect , sx, sy, sx+dx*(ban_size-1)+db*2, sy+dx*(ban_size-1)+db*2 );
//	hBrush = CreateSolidBrush( RGB( 192,64,0 ) ); // Z(192,64,0) W(255,128,0)
//	hBrush = CreateSolidBrush( RGB( 128,128,64 ) ); // Z(192,64,0) W(255,128,0)
	hBrush = CreateSolidBrush( RGB( 128,128,0 ) ); // Z(192,64,0) W(255,128,0)
	FillRect( ps.hdc, &rRect, hBrush );
	DeleteObject(hBrush);
			
   	hPen = CreatePen(PS_SOLID, 1, RGB( 0,0,0 ) );
	hPenOld = SelectObject( ps.hdc, hPen );
	for (x=1;x<ban_size-1;x++) {
		MoveToEx( ps.hdc, x*dx+sx+db , sy+db, NULL );
        LineTo( ps.hdc, x*dx+sx+db , sy+db+dx*(ban_size-1) );
		MoveToEx( ps.hdc, sx+db      , x*dx+sy+db, NULL );
        LineTo( ps.hdc, sx+db+dx*(ban_size-1) , x*dx+sy+db );
	}
	SelectObject( ps.hdc, hPenOld );
	DeleteObject(hPen);

   	hPen = CreatePen(PS_SOLID, 2, RGB( 0,0,0 ) );
	SelectObject( ps.hdc, hPen );
	MoveToEx( ps.hdc, sx+db , sy+db, NULL );
	LineTo( ps.hdc, sx+db , sy+db+dx*(ban_size-1) );
	LineTo( ps.hdc, sx+db+dx*(ban_size-1), sy+db+dx*(ban_size-1) );
	LineTo( ps.hdc, sx+db+dx*(ban_size-1), sy+db );
	LineTo( ps.hdc, sx+db, sy+db );
	SelectObject( ps.hdc, hPenOld );
	DeleteObject(hPen);

	/* ̓_ */
	SelectObject( ps.hdc, hBrushBlack );
//	if ( ban_size == BAN_19 ) {
    	for ( i=0;i<3;i++) {
    		x =  sx+db+dx*3 + dx*6*i;
    		for ( j=0;j<3;j++) {
		    	y =  sy+db+dx*3 + dx*6*j;
		    	Ellipse( ps.hdc, x-2,y-2, x+3,y+3);
			}
		}
//	}

	/* 莚uʁv̕\ */
	x = sx+db*2+dx*(ban_size);
	y = 20;
	hFont = CreateFont( 48,0, 0, 0, FW_BOLD, 0, 0, 0,
		SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS,
		CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
		FIXED_PITCH | FF_SCRIPT, "script");
	hFontOld = SelectObject( ps.hdc, hFont );
	SetBkMode( hDC, TRANSPARENT);	// TRANSPARENT ... d˂, OPAQUE...hԂ
	SetTextColor( hDC, RGB(0,0,0) );		// e
	TextOut( hDC, x+4, y+4, "GnuGo",5 );
	SetTextColor( hDC, RGB(255,255,255) );	//@𔒂
	TextOut( hDC, x-1, y-1, "GnuGo",5 );
	TextOut( hDC, x+1, y-1, "GnuGo",5 );
	TextOut( hDC, x-1, y+1, "GnuGo",5 );
	TextOut( hDC, x+1, y+1, "GnuGo",5 );
	SetTextColor( hDC, RGB(128,0,128) );
	TextOut( hDC,   x,   y, "GnuGo",5);

   	hPen = CreatePen(PS_SOLID, 2, RGB( 0,255,0 ) );
	hPenOld = SelectObject( ps.hdc, hPen );
	MoveToEx( ps.hdc,  x-10, 75, NULL );
	LineTo( ps.hdc, x+134, 75 );
	MoveToEx( ps.hdc,  x-10,  15, NULL );
	LineTo( ps.hdc, x+134,  15 );
	SelectObject( ps.hdc, hPenOld );
	DeleteObject(hPen);
	SelectObject( ps.hdc, hFontOld );
	DeleteObject(hFont);


	/*  */
	SetTextColor( hDC, RGB(255,255,255) );	//@𔒂

	hFontOld = SelectObject(hDC,GetStockObject(SYSTEM_FIXED_FONT));
//	hFont = CreateFont( 18,0, 0, 0, FW_BOLD, 0, 0, 0,
//		SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS,
//		CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
//		DEFAULT_PITCH | FF_SCRIPT, "lr ");
	hFontOld = SelectObject( ps.hdc, hFont );
	for (i=0;i<ban_size;i++) {
		sprintf( sNum,"%d",ban_size - i);
		TextOut( hDC, 0 + (i>9)*5, sy+db-8 + i*dx, sNum ,strlen(sNum) );
//		TextOut( hDC, sx+db+dx*ban_size+(i>9)*5-4, sy+db-8 + i*dx, sNum ,strlen(sNum) );
		sprintf( sNum,"%c",i+65+(i>7) );
		TextOut( hDC, sx+db-4 + i*dx, 0, sNum ,strlen(sNum) );
//		TextOut( hDC, sx+db-4 + i*dx, sy+db+dx*ban_size, sNum ,strlen(sNum) );
	}

	SelectObject( ps.hdc, hFontOld );
//	DeleteObject(hFont);


	/* Ֆʂɂ΂\ */
	for (y=0;y<ban_size;y++) {
		for (x=0;x<ban_size;x++) {
//			z = ((y+1)<<8) + (x+1);
	    	xx = sx+db+dx*x;
	    	yy = sy+db+dx*y;

			k = p[y][x];

			if ( k == EMPTY ) continue;
			if ( k == BLACK ) SelectObject( hDC, hBrushBlack );		// 
			else              SelectObject( hDC, hBrushWhite );		// 

	    	Ellipse( ps.hdc, xx-dx/2,yy-dx/2, xx+dx/2,yy+dx/2);		// Windows98 ł͂BȂH
//			Chord( ps.hdc,  xx-dx/2,yy-dx/2, xx+dx/2,yy+dx/2, xx-dx/2,yy-dx/2, xx-dx/2,yy-dx/2 );	// Ellipse ͓삪i͂ݏoj
		}
	}

	SelectObject( hDC, hBrushBlack );		// 
   	xx =  sx+db*2+dx*ban_size;
   	yy =  120;
   	hPen = CreatePen(PS_SOLID, 1, RGB( 255,255,255 ) );
	hPenOld = SelectObject( ps.hdc, hPen );
 	Ellipse( ps.hdc, xx-13,yy-13, xx+13,yy+13);
	SelectObject( ps.hdc, hPenOld );
	DeleteObject(hPen);
    SelectObject( hDC, hBrushWhite );		// 
   	yy =  210;
 	Ellipse( ps.hdc, xx-13,yy-13, xx+13,yy+13);


	/* ̑̉ʏ */
	hFontOld = SelectObject(hDC,GetStockObject(SYSTEM_FIXED_FONT));
	SetTextColor( hDC, RGB(255,255,255) );	// 𔒂

	sprintf( sNum,"%s",sPlayerName[0]);	// Player name
	TextOut( hDC, xx+20,113, sNum ,strlen(sNum) );
	sprintf( sNum,"%s",sPlayerName[1]);	// Player name
	TextOut( hDC, xx+20,203, sNum ,strlen(sNum) );

	if ( mymove==BLACK ) sprintf( sNum,"Hama= %2d",uk);
	else                 sprintf( sNum,"Hama= %2d",mk);
	TextOut( hDC, xx-16,146, sNum ,strlen(sNum) );
	if ( mymove==BLACK ) sprintf( sNum,"Hama= %2d",mk);
	else                 sprintf( sNum,"Hama= %2d",uk);
	TextOut( hDC, xx-16,236, sNum ,strlen(sNum) );

//	sprintf( sNum,"Hama= %2d",mk);
//	TextOut( hDC, xx-16,146, sNum ,strlen(sNum) );
//	sprintf( sNum,"Hama= %2d",uk);
//	TextOut( hDC, xx-16,236, sNum ,strlen(sNum) );
 
	sprintf( sNum,"Node= %3d,",tesuu);
	TextOut( hDC, xx-16,300, sNum ,strlen(sNum) );
	if ( kifu[tesuu][0]==0 ) sprintf( sNum,"PASS");
	else {
		z = kifu[tesuu][0];
		x = z & 0x00ff;
		y = z / 256;
		x = x + (x>9);	// not use 'I'
		y = 20 - y;
	    sprintf( sNum,"%c%d",'A'+x-1,y);
	}
	TextOut( hDC, xx-16+8*11,300, sNum ,strlen(sNum) );
//	sprintf( sNum,"Ȃ̔Ԃł");
//	TextOut( hDC, xx-16,320, sNum ,strlen(sNum) );
	SelectObject( ps.hdc, hFontOld );

  EndPaint(hWnd, &ps);
	DeleteObject(hBrushWhite);
	DeleteObject(hBrushBlack);
}

/*** }EX̍NbN̎̈ʒuxyWɕϊĕԂ ***/
/*** ǂwĂȂƂ͂OԂ                     ***/
int ChangeXY(LONG lParam)
{
	int dx,sx,sy,db;
	int x,y;
	
//	GetScreenParam( hWndDraw,&dx, &sx, &sy, &db );
	dx = 10; sy = 10; db = 5; sx = 5;
	x = LOWORD(lParam);
	y = HIWORD(lParam);
	x -= sx + db - dx/2;	// Ղ̍îɐ΂P̍jɕsړ
	y -= sy + db - dx/2;
//	if ( x < 0	|| x > dx*ban_size ) return 0;
//	if ( y < 0  || y > dx*ban_size ) return 0;
	x = x / dx;
	y = y / dx;
	return ( ((y+1)<<8) + x+1);
}

/*** Ֆʐݒp@NbNōAEŔu ***/
void SetIshi( int z, int flag )
{
	int x,y;
	int dx,sx,sy,db;
	RECT rc;

	GetScreenParam( hWndDraw, &dx, &sx, &sy, &db );
	if ( ban[z] != flag ) ban[z] = flag;
	else ban[z] = 0;

	x = z & 0xff;
	y = z >> 8;
	x = (x-1) * dx;
	y = (y-1) * dx;

	SetRect( &rc, sx+db-dx/2 +x , sy+db-dx/2 +y, sx+db+dx/2 +x, sy+db+dx/2 +y );
	InvalidateRect( hWndDraw, &rc, TRUE );

}


/*** XV͈͂̓Bʂ̑Sj~iɌĂԁj***/
void PaintLittle(void)
{
	int k,x,y,z;
	int dx,sx,sy,db;
	RECT rc;
	static int ban_before[BANMAX];
	static int tesuu_before = 0;

	GetScreenParam( hWndDraw, &dx, &sx, &sy, &db );

	z = kifu[tesuu][0];	// ʒu
	if ( z != 0 ) ban_before[z] = 0;	// ΂ɔԍt邽߂ɍ׍HB΂߂Ƃłĕ`悳B

	for (y=0;y<ban_size;y++) {
		for (x=0;x<ban_size;x++) {
			z = ((y+1)<<8) + (x+1);
			k = ban[z];
			if ( ban_before[z] != k ) {
				ban_before[z] = k;

				SetRect( &rc, sx+db+dx*x -dx/2, sy+db+dx*y -dx/2, sx+db+dx*(x+1) -dx/2, sy+db+dx*(y+1) -dx/2);
				InvalidateRect( hWndDraw, &rc, FALSE );
			}
		}
	}

   	// ΂̐
 	x = sx+db*2+dx*ban_size;
	y = 146;
	SetRect( &rc, x+32, y, x+90, y+20);
	InvalidateRect( hWndDraw, &rc, TRUE );

	y = 236;
	SetRect( &rc, x+32, y, x+90, y+20);
	InvalidateRect( hWndDraw, &rc, TRUE );

	// 萔Ƒłꏊ
	y = 300;
	SetRect( &rc, x+32, y, x+120, y+20);
	InvalidateRect( hWndDraw, &rc, TRUE );

	UpdateWindow(hWndDraw);
}
